import matplotlib.pyplot as plt
import numpy as np
#from src import B_field_calculation as bf

from src import coil_class as BC
from src import physical_constants as cs


Wire_1 = [0.5, 0.568]
#Wire_1 = [0.45, 0.514]
#I_current = 0.94
HH_Coil = BC.BCoil(HH = 1, distance = 54, radius = 48, layers = 8, windings = 8, wire_height = Wire_1[0], wire_width = Wire_1[0], insulation_thickness=(Wire_1[1] - Wire_1[0]) / 2, is_round = True, winding_scheme= 2)

e_cu = 3e-2  # emissivity copper, polished

rho_cu = 1.7 * 1e-8

I = 3  # A

surface = 10e-4
# S_coil = S_coil/2
print(f"Surface area = {surface}")


def power_bal(T, h_air):
    T_0 = 22.5
    P = 100e-3

    f = h_air * surface * (T - T_0) - 0.5 * P
    return f


print(e_cu * surface * cs.sigma_B ** 4 * (50 ** 4 - 22.5 ** 4))
T = np.linspace(20, 120, 500)
T_calc = np.linspace(20, 2200, 1000)

for h_air in [2.5, 10, 25]:
    pos_min = np.argmin(np.abs(power_bal(T_calc, h_air)))
    T_SS = T_calc[pos_min]
    print(f"T_ss = {T_SS} °C")
    plt.plot(T, power_bal(T, h_air), label=f"$h_{{air}} = {h_air} \; W/m^2 K$ , $T_{{SS}}$ = {T_SS:.2f}°C")
plt.ylabel("Power balance [W]")
plt.xlabel("temparature [°C]")
plt.title(f"Power balance, free convection, AHH coil, I = {I} A, windings: 4 x 4")
plt.legend()
plt.show()

print(AHH_opt.power(I, 25) / 2)